VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7470
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4425
   LinkTopic       =   "Form1"
   ScaleHeight     =   7470
   ScaleWidth      =   4425
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picPP 
      BackColor       =   &H00FFFFFF&
      Height          =   5895
      Left            =   1080
      ScaleHeight     =   5835
      ScaleWidth      =   3195
      TabIndex        =   3
      Top             =   1200
      Width           =   3255
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert"
      Default         =   -1  'True
      Height          =   495
      Left            =   1080
      TabIndex        =   2
      Top             =   600
      Width           =   3255
   End
   Begin VB.ListBox lstRPN 
      Height          =   6495
      ItemData        =   "RPN.frx":0000
      Left            =   120
      List            =   "RPN.frx":0002
      TabIndex        =   1
      Top             =   600
      Width           =   855
   End
   Begin VB.TextBox txtEquation 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Op As String
Dim CurLevel As Integer
Dim Level As Integer

Dim OpStack(100) As String
Dim LevelStack(100) As Integer
Dim StackTop As Integer

Sub Push(Op As String, Level As Integer)
    StackTop = StackTop + 1
    OpStack(StackTop) = Op
    LevelStack(StackTop) = Level
End Sub

Function Pop() As Boolean
    If StackTop = -1 Then
        Pop = False
        Exit Function
    End If
    Op = OpStack(StackTop)
    Level = LevelStack(StackTop)
    StackTop = StackTop - 1
    Pop = True
End Function

Private Sub cmdConvert_Click()
Dim CurOp As String
Dim NextNum As String
Dim x As Integer
    
    lstRPN.Clear
    
    StackTop = -1

    For x = 1 To Len(txtEquation.Text)
        CurOp = Mid(txtEquation.Text, x, 1)
        
        If (Asc(CurOp) >= Asc("0") And Asc(CurOp) <= Asc("9")) Or CurOp = "." Then
            Do
                If x < Len(txtEquation.Text) Then
                    NextNum = Mid(txtEquation.Text, x + 1, 1)
                    If Asc(NextNum) >= Asc("0") And Asc(NextNum) <= Asc("9") Or NextNum = "." Or NextNum = "e" Then
                        CurOp = CurOp & NextNum
                        x = x + 1
                    Else: Exit Do
                    End If
                Else: Exit Do
                End If
            Loop
            If Trim(Str(Val(CurOp))) <> CurOp Then
                MsgBox "Invalid Number: " & CurOp, , "Error"
                Exit Sub
            End If
            lstRPN.AddItem CurOp
            
        ElseIf CurOp = "x" Or CurOp = "y" Then
            lstRPN.AddItem CurOp
        
        ElseIf CurOp = "+" Or CurOp = "-" Then
            Do While Pop
                If Level = CurLevel Then
                    lstRPN.AddItem Op
                Else
                    Push Op, Level
                    Exit Do
                End If
            Loop
            Push CurOp, CurLevel
            
        ElseIf CurOp = "*" Or CurOp = "/" Then
            Do While Pop
                If Level = CurLevel And Op = "^" Then
                    lstRPN.AddItem Op
                Else
                    Push Op, Level
                    Exit Do
                End If
            Loop
            Push CurOp, CurLevel

        
        ElseIf CurOp = "^" Then
            Push CurOp, CurLevel
        
        ElseIf CurOp = "(" Then
            CurLevel = CurLevel + 1
        
        ElseIf CurOp = ")" Then
            Do While Pop
                If Level = CurLevel Then
                    lstRPN.AddItem Op
                Else
                    Push Op, Level
                    Exit Do
                End If
            Loop
            CurLevel = CurLevel - 1
            
        Else
            MsgBox "Unrecognised Symbol: " & CurOp, , "Error"
            Exit Sub
        End If
    Next
    
    Do While Pop = True
        lstRPN.AddItem Op
    Loop
End Sub

Private Sub Form_Load()
    StackTop = -1
End Sub
